from pathlib import Path

import pendulum
from airflow.decorators import dag, task

EXTERNAL_PYTHON = "/home/airflow/barebone-venv/bin/python"
BASE_PATH = Path("/opt/airflow/output")


@task.external_python(python=EXTERNAL_PYTHON)
def make_paths(base_path: str, x: int) -> str:
    from pathlib import Path
    base_path = Path(base_path)
    ret = base_path / f"try_{x}"

    return str(ret)


@task.external_python(python=EXTERNAL_PYTHON)
def print_paths(input_paths: list[str]) -> None:

    print("########################################################################")
    for path in input_paths:
        print(path)

    print("########################################################################")



@dag(
    schedule=None,
    start_date=pendulum.datetime(2024, 10, 18),
)
def test_dag() -> None:
    lists = make_paths.partial(base_path=str(BASE_PATH / "xcom")).expand(x=[1, 2])
    print_paths(input_paths=lists)

test_dag()
